## gnuplot 6.0.0+dfsg1

=== config/mingw/Makefile ===
# Hello, emacs: this is a -*- Makefile -*-
#
# GNUPLOT Makefile for MinGW/MSYS or MinGW-w64/MSYS2 on Windows 
#
# Note: Currently MinGW cannot be used to compile gnuplot unless
#       libraries / headers are updated.
# Note that Mingw-w64 needs to be configured with --enable-secure-api, and
#       MINGW_HAS_SECURE_API must be defined in _mingw.h.
#
# See http://www.mingw.org or http://msys2.github.io/ for more details.

# To compile gnuplot for Windows:
# - Change the configuration section in 'config/mingw/Makfile' to
#   match your setup.
# - On the MSYS/MSYS2 prompt, change directory to 'config/mingw' and issue
#   the commands
#	 make all
#	 make install
#
# This makefile was tested with 
#   MSYS, MinGW32 and Microsoft HTML Help 1.4 SDK.
#   MSYS2, MinGW-w64


#
# ************** Begin of Configuration section ************************
#

# Choose target to compile:
# 1. PLAIN: wgnuplot.exe: The usual Windows GUI for input commands.
# 2. PIPES: wgnuplot_pipes.exe: Like wgnuplot, but with an additional console
#    window, so you can see the output of commands like
#      plot '<awk -f preprocess.awk my.dat')  or  x=system('ls -1')
# 3. CONSOLE: gnuplot.exe: Console mode instead of GUI for the text input.
#

# Enable exactly one of these:
VARIANT = PLAIN
#VARIANT = PIPES
#VARIANT = CONSOLE

# Comment out the definition lines to disable the according features:

# Define this only if doing a release build
#RELEASE=1

# Set-up your compiler environment
#
# Define if you are using MSYS2/MinGW64 instead of MSYS/MinGW
MINGW64=1
# Define if you want a 32bit version (even using a 64bit compiler)
#M32=1
# Define if you use clang instead of gcc, requires MINGW64
#CLANG=1
# Use the colorgcc frontend explicitly
#COLORGCC=1
# Specify the path to the compiler unless it is already in PATH
#CCPATH = g:/mingw32/bin/
#CCPATH = c:/apps/mingw/bin/

# Path to 32bit programs
# On 32bit machines:
#PROGRAMFILES32="$(PROGRAMFILES)"
#PROGRAMFILES32=/c/Program\ Files
# On 64bit machines: (no access to ProgramFiles(x86) variable!)
PROGRAMFILES32=/c/Program\ Files\ \(x86\)

# Define if you would like a UNICODE build
UNICODE=1

# GIF, PNG, JPEG device drivers
# Requires gd library. There are two possibilities how to configure these
# drivers for use in gnuplot, depending on the gd version. See README.1ST for
# more details.
#
# You should compile gnuplot with GD library v2.0 or newer.
# This library writes PNG, GIF and JPEG images.
# If libgd has been compiled with TrueType font support, then you can use
# scaled TrueType fonts. If not, then uncomment FREETYPE.
# Requires GD, PNG and Z libraries, optionally libfreetype.
# In some cases, libfreetype can depend on additional libraries such as
# fontconfig or iconv; then, uncomment GDAUTOCONFIGLIBS so that all of the
# libraries needed for linking will be taken by running 'gdlib-config'.
# Uncomment BGD if you want to use the binary DLL version of libgd.
#NEWGD=1
#JPEG=1
#FREETYPE=1
#GDAUTOCONFIGLIBS=1
#GDPKGCONFIG=1
#BGD=1

# PDF device driver
# Requires PNG and Z libraries based on particular PDF library used, and
# optionally also TIFF library according to
# 1. defined PDF_NOTIFF:
#    'Light' pdf library (produces wgnuplot.exe only 200 KB larger!)
#    You can get this pdf library by compiling it without PNG, GD and TIFF
#    support: change  pdflib/p_intern.h  and recompile the pdf library.
#    Gnuplot does not use the tiff routines, and gd/png are elsewhere.
# 2. undefined PDF_NOTIFF:
#    Full pdf library (produces wgnuplot.exe 500 KB larger!)
#PDF=1
#PDF_NOTIFF=1

# DEBUGging support
# creates binaries suitable for debugging. Some bugs may come and go
# as opposed to a production build since we lower the optimization level
#DEBUG=1

# MOUSE support for the windows terminal
MOUSE=1

# Cairo/Pango terminals
# Uncomment the following lines to select the pngcairo and pdfcairo
# terminals
#CAIROTERMS=1
#CAIROLIBS=1

# wxt interactive terminal
# Requires wxWidgets, Cairo, Pango, and their respective dependencies.
# Uncomment the following lines to compile it.
#WXT=1
#CAIROLIBS=1

# Include webp terminal 
# Requires webp lib and cairo libraries.
#WEBP=1

# Build qt terminal?
#QT=1
# specify QT installation directory
#QT_DIR = /c/Qt/5.2.1/mingw48_32
ifndef MINGW64
QT_DIR = /d/Source/Qt-5.2.1-mingw/5.2.1/mingw48_32
else
ifdef M32
QT_DIR = /mingw32
else
QT_DIR = /mingw64
endif
endif

# Uncomment the following line to select the lua/tikz terminal
#LUA=lua

# Uncomment the following line to select the caca terminal
# Requires libcaca version 0.99.beta15 or newer. A post-beta18
# svn version is recommended since it contains an improved
# win32 backend.
#CACA=1

# Uncomment if you have libiconv
ICONV=1

# Uncomment if you have libcerf
# https://jugit.fz-juelich.de/mlz/libcerf
CERF=1

# Uncomment if you have libopenspecfun
# https://github.com/JuliaMath/openspecfun
OPENSPECFUN=1

# Uncomment if console mode gnuplot should use GNU readline
# (not recommended)
#GNUREADLINE=1

# Uncomment if you want to use watchpoints
#WATCHPOINTS=1

# Uncomment if you want to use polar grid
#POLAR_GRID=1

# Uncomment if you want to use functionblocks
#FUNCTIONBLOCKS=1

# Uncomment if you want a stable sort for pm3d and hidden3d surfaces
#STABLE_SORT=1

# Uncomment if you want to use Direct2D 1.1 (Windows 8 and Windows 7 Platform Update)
DIRECT2D11=1

# GRX graphics library, for debugging the DJGPP svga terminal
#GRX=1
GRXPATH=c:/Source/grx249
# or, the MGRX fork of GRX
#MGRX=1
MGRXPATH=c:/Source/mgrx


# Below you can adapt paths according to your software setup:

# Where to install the PostScript prologue files, relatively to the
# executable in bin/wgnuplot.exe
GNUPLOT_PS_DIR = share/PostScript

# Similarly for javascript files for the canvas terminal:
GNUPLOT_JS_DIR = share/js

# Similarly for translation files for the qt terminal:
GNUPLOT_QT_DIR = share/qt

# Similarly for scripts used by the lua terminal
GNUPLOT_LUA_DIR = share/lua

# Install will put TeX files here:
GNUPLOT_TEX_DIR = share/texmf/tex

# gnuplot will look for gnuplotrc here:
GNUPLOT_SHARE_DIR = share

# Destination directory, used in 'make install':
#DESTDIR = /local/opt/gnuplot-4.5
DESTDIR = "$(PROGRAMFILES)/gnuplot"

# Do you want some special optimization / flags?
#CFLAGS +=
CWFLAGS += -Wno-unused-function
ifdef CLANG
CFLAGS += -fcolor-diagnostics -fansi-escape-codes
CWFLAGS += -Wno-incompatible-ms-struct -Wno-ignored-attributes
CWFLAGS += -Wno-infinite-recursion
CXXFLAGS += -std=c++11
endif
ifdef MINGW64
# This does not seem to work even if GCC_COLORS is set.
#CFLAGS += -fdiagnostics-color=always
endif

# To compile the .chm file you need the Microsoft HTML Help 1.4 SDK
# It can be obtained here:
# http://go.microsoft.com/fwlink/?LinkId=154968
# We need to explicitly set the correct path here since we also need
# adjust the include and library paths.
HHWPATH = $(PROGRAMFILES32)/HTML\ Help\ Workshop/
HHC = $(HHWPATH)hhc

# Choose which resource compiler you want to use (GNU windres or MS rc):
GNU_RC = 1
ifndef GNU_RC
  # If uncommented GNU_RC above and rc.exe not in PATH, then set:
  MSSDK = c:/mssdk
endif

# GNU sort
GNUSORT = /bin/sort

# Inno Setup Compiler
# get it from: http://www.jrsoftware.org/isdl.php
# Use unicode version of Inno Setup Compiler but not Standard version
# because the setup file of gnuplot installer is now encoded utf-8 with BOM.
ISCC = $(PROGRAMFILES32)/Inno\ Setup\ 6/iscc

#DLLS = 1

# Directory that might contain extra files to be shipped with the installer.
# This should include dependencies like DLLs, but also fontconfig configuration files.
ifdef MINGW64
ifdef M32
#EXTRADIST = /d/gnuplot/dist32
else
#EXTRADIST = /d/gnuplot/dist64
endif
else
#EXTRADIST = /d/gnuplot/dist
endif

#
# *************** End of Configuration section *************************
#


#         There shouldn't be anything to be changed below this line
# **********************************************************************
#

# We enforce to use console mode gnuplot to run gnuplot scripts in order
# to see their output during make.
TARGET=gnuplot.exe

BUILT_SOURCES = allterm.h allterm-ja.h

ifdef MINGW64
ifdef M32
CFLAGS += -m32
else
CFLAGS += -m64
endif
else
# MINGW32 always produces 32bit executables
ifndef M32
M32=1
endif
endif

ifndef CLANG
ifdef COLORGCC
CC=$(CCPATH)color-gcc
CXX=$(CCPATH)color-g++
else # !COLORGCC
ifdef (CCPATH)
CC = $(CCPATH)gcc
CXX = $(CCPATH)g++
else #!CCPATH
CC = gcc
CXX = g++
endif
endif
else # CLANG
CC = $(CCPATH)clang
CXX = $(CCPATH)clang++
endif
LD = $(CC)
LDX = $(CXX)

RM = rm -f
CP = cp -p

ifdef DEBUG
  CFLAGS += -g -Wall -pipe
  LDFLAGS += -g
else
  CFLAGS += -O2 -pipe
  LDFLAGS += -s
endif

ifdef UNICODE
  CFLAGS += -DUNICODE -D_UNICODE
  LDFLAGS2 += -municode
endif

CFLAGS += $(CWFLAGS)

TOP = ../..

# macros for makefile.all
O=o
S=$(TOP)/src
W=$(S)/win
T=$(TOP)/term/
D=$(TOP)/docs/
M=$(TOP)/demo/

VPATH = $(S):$(S)/wxterminal

CFLAGS += -DGNUPLOT_PS_DIR=\"$(GNUPLOT_PS_DIR)\" 
TERMFLAGS = -DGNUPLOT_JS_DIR=\"$(GNUPLOT_JS_DIR)\"

TERMLIBS =

CFLAGS += -I. -I$(S) -I$(T) -DHAVE_CONFIG_H
CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
CFLAGS += -DWITH_CHI_SHAPES=1
CFLAGS += -DGNUPLOT_SHARE_DIR=\"$(GNUPLOT_SHARE_DIR)\"

CFLAGS_DOCS = -I. -I$(S) -DHAVE_CONFIG_H

ifndef RELEASE
  CFLAGS += -DDEVELOPMENT_VERSION
endif

ifdef MOUSE
  CFLAGS += -DUSE_MOUSE=1 -DWIN_IPC
endif

# Name of helpfiles:
HELPFILE = wgnuplot.chm
HELPFILEJA = wgnuplot-ja.chm
CFLAGS += -I$(HHWPATH)include
BUILDHELPFILE = $(D)windows/$(HELPFILE)

ifdef NEWGD
  GD=1
  PNG=1
endif

ifdef GD
  CFLAGS += -DHAVE_LIBGD
  ifndef BGD
    TERMLIBS += -lgd
  else
    TERMLIBS += -lbgd
  endif
endif

ifdef PNG
  CFLAGS += -DHAVE_LIBPNG
  ifndef BGD
  ifndef GDAUTOCONFIGLIBS
  ifndef GDPKGCONFIG
    TERMLIBS += -lpng -lz
  endif
  endif
  endif
endif

ifdef NEWGD
  CFLAGS += -DHAVE_LIBGD -DHAVE_GD_H -DHAVE_GD_GIF -DGIF_ANIMATION -DHAVE_GD_PNG
ifdef GDPKGCONFIG
  CFLAGS += $(shell pkg-config --cflags gdlib)
endif
ifdef JPEG
  CFLAGS += -DHAVE_GD_JPEG
  ifndef BGD
  ifndef GDAUTOCONFIGLIBS
  ifndef GDPKGCONFIG
    TERMLIBS += -ljpeg
  endif
  endif
  endif
endif
ifdef FREETYPE
  CFLAGS += -DHAVE_GD_TTF
  ifndef BGD
  ifndef GDAUTOCONFIGLIBS
  ifndef GDPKGCONFIG
    TERMLIBS += -lfreetype
  endif
  endif
  endif
endif
ifdef GDAUTOCONFIGLIBS
  TERMLIBS += $(shell gdlib-config --libs)
endif
ifdef GDPKGCONFIG
  TERMLIBS += $(shell pkg-config --libs gdlib)
endif
endif

ifdef PDF
  CFLAGS += -DHAVE_LIBPDF
ifdef PDF_NOTIFF
  TERMLIBS += -lpdf_notiff
else
  TERMLIBS += -lpdf -ltiff
#  TERMLIBS += -lpdf-w -ltiff-w
endif
ifndef PNG
  NEED_PNG_W = 1
else
ifndef NEWGD
  NEED_PNG_W = 1
endif
endif
ifdef NEED_PNG_W
  CFLAGS += -DHAVE_LIBPNG
  TERMLIBS += -lpng-w -lz-w
endif
endif

ifdef CAIROLIBS
	CAIRO_CFLAGS := $(shell pkg-config --cflags cairo | sed s_-Ic:_-I/c_g)
	PANGOCAIRO_CFLAGS := $(shell pkg-config --cflags glib-2.0 gobject-2.0 pangocairo cairo | sed s_-Ic:_-I/c_g)
	PANGOCAIRO_LIBS := $(shell pkg-config --libs glib-2.0 gobject-2.0 pangocairo cairo | sed s_-Lc:_-L/c_g)
	CAIRO_OBJS := gp_cairo.$(O) gp_cairo_helpers.$(O)
	TERMFLAGS += $(PANGOCAIRO_CFLAGS)
endif

ifdef CAIROTERMS
	CFLAGS += -DHAVE_CAIROPDF
	TERMFLAGS += -DHAVE_CAIROEPS
ifdef WEBP
	CFLAGS += -DHAVE_WEBP
	TERMLIBS += -lwebp -lwebpmux
endif
endif

ifdef WXT
	CFLAGS += -DWXWIDGETS
	WXT_CXXFLAGS := $(shell wx-config --cxxflags)
	CXXFLAGS += $(WXT_CXXFLAGS)
	WX_LIBS := $(shell wx-config --libs | sed -e "s+-Wl,--subsystem,windows++g" -e "s+-mwindows++g")
	WX_OBJS = wxt_gui.$(O)
endif

ifdef QT
	QT_LIBS = -lQt5Core -lQt5Gui -lQt5Network -lQt5Svg -lQt5Widgets -lQt5PrintSupport -lqtmain
	QT_CXXFLAGS =  -I$(QT_DIR)/include -I$(QT_DIR)/include/Qt -I$(QT_DIR)/include/QtCore -I$(QT_DIR)/include/QtGui
	QT_CXXFLAGS += -I$(QT_DIR)/include/QtWidgets -I$(QT_DIR)/include/QtNetwork
	QT_CXXFLAGS += -I$(QT_DIR)/include/QtSvg -DQTGNUPLOT_DATA_DIR=\"$(GNUPLOT_QT_DIR)\"
	QT_LDFLAGS = -L$(QT_DIR)/lib

	CFLAGS += -DQTTERM -DQT_NO_OPENGL
	TERMLIBS += $(QT_LIBS)
	CXXFLAGS += $(QT_CXXFLAGS)

=== debian/changelog ===
gnuplot (6.0.0+dfsg1-1ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:16:36 +0000

gnuplot (6.0.0+dfsg1-1ubuntu2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:29:42 +0000

gnuplot (6.0.0+dfsg1-1ubuntu1) noble; urgency=medium

  * Fix a memory error in doc2tex when generating PDF files (LP: #2057714).

 -- Zixing Liu <zixing.liu@canonical.com>  Tue, 12 Mar 2024 17:39:14 -0600

gnuplot (6.0.0+dfsg1-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 04:46:55 +0000

gnuplot (6.0.0+dfsg1-1) unstable; urgency=medium

  * [c4752fd] New upstream version 6.0.0+dfsg1
  * [dbf032e] Update patches
  * [593d5f1] Use secure URI in Homepage field.
  * [dc1938a] Update standards version to 4.6.2, no changes needed.

 -- Anton Gladky <gladk@debian.org>  Tue, 20 Feb 2024 21:13:03 +0100

=== debian/control ===
Source: gnuplot
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: math
Priority: optional
Build-Depends: autoconf,
               automake,
               debhelper-compat (= 13),
               dh-lua,
               libcairo2-dev,
               libedit-dev,
               libgd-dev,
               liblua5.1-0-dev,
               libpango1.0-dev,
               libpng-dev,
               qtbase5-dev,
               qtbase5-dev-tools,
               qttools5-dev-tools,
               libqt5svg5-dev,
               libx11-dev,
               libxt-dev,
               pkg-config,
               libwxgtk3.2-dev,
               libwxgtk3.2-dev,
               zlib1g-dev
Build-Depends-Indep: latex2html,
                     texinfo,
                     texlive-fonts-recommended,
                     texlive-font-utils,
                     texlive-latex-base,
                     texlive-latex-extra,
                     texlive-latex-recommended,
                     texlive-science,
                     texlive-xetex,
                     texlive-fonts-extra,
                     fonts-freefont-ttf,
                     fonts-freefont-otf,
                     emacs-nox
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/gnuplot
Vcs-Git: https://salsa.debian.org/science-team/gnuplot.git
Homepage: https://gnuplot.sourceforge.net/
Rules-Requires-Root: no

Package: gnuplot
Architecture: all
Depends: gnuplot-qt | gnuplot-x11 | gnuplot-nox,
         ${misc:Depends}
Suggests: gnuplot-doc
Description: Command-line driven interactive plotting program.
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on. The X11-output
 is packaged in gnuplot-x11.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This metapackage is to install a full-featured gnuplot (-qt, -x11 or -nox).

Package: gnuplot-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Command-line driven interactive plotting program. Doc-package
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This package contains the additional documentation.

Package: gnuplot-nox
Architecture: any
Depends: gnuplot-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: fonts-liberation,
            groff
Suggests: gnuplot-doc
Conflicts: gnuplot-qt,
           gnuplot-x11
Provides: gnuplot
Replaces: gnuplot-qt,
          gnuplot-x11
Description: Command-line driven interactive plotting program. No-X package
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on. The X11-output
 is packaged in gnuplot-x11. The QT-output is packaged in gnuplot-qt.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This package is for working without an X server.

Package: gnuplot-qt
Architecture: any
Depends: gnuplot-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: gnuplot-doc
Conflicts: gnuplot-x11,
           gnuplot-nox
Provides: gnuplot-nox,
          gnuplot-x11,
          gnuplot
Replaces: gnuplot-x11,
          gnuplot-nox
Description: Command-line driven interactive plotting program. QT-package
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This package contains the terminal driver that enables gnuplot to plot
 images interactively using Qt.
 .
 The package provides gnuplot-x11 and gnuplot-nox terminals plus an
 additional QT-terminal for output.

Package: gnuplot-x11
Architecture: any
Depends: gnuplot-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: gnuplot-doc
Conflicts: gnuplot-qt,
           gnuplot-nox
Provides: gnuplot-nox,
          gnuplot
Replaces: gnuplot-qt,
          gnuplot-nox
Description: Command-line driven interactive plotting program. X-package
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This package contains the terminal driver that enables gnuplot to plot
 images interactively under X11.

Package: gnuplot-data
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: aglfn,
         ${misc:Depends}
Description: Command-line driven interactive plotting program. Data-files
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on. The X11-output
 is packaged in gnuplot-x11.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This package contains data-files which are used by -nox, -x11 and -qt.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

# Tell compiler where should find lua headers
export DEB_CFLAGS_MAINT_APPEND = -I/usr/include/lua5.1

# Force the use of qt5
export QT_SELECT=qt5

# Qt insists on using -fPIC
export DEB_CXXFLAGS_MAINT_APPEND = -fPIC

# For reproducible builds
export FORCE_SOURCE_DATE = 1

BUILDDIR_NOX = $(CURDIR)/debian/build-nox
BUILDDIR_X11 = $(CURDIR)/debian/build-x11
BUILDDIR_QT = $(CURDIR)/debian/build-qt
MANPNOX = $(CURDIR)/debian/gnuplot-nox/usr/share/man/man1/gnuplot-nox.1

conf_opts += \
	--prefix=/usr \
	--mandir=\$${prefix}/share/man \
	--libexecdir=\$${prefix}/lib/gnuplot \
	--datadir=\$${prefix}/share/gnuplot \
	--with-gihdir=\$${prefix}/share/gnuplot \
	--without-lasergnu \
	--with-png \
	--with-gd \
	--without-lisp-files \
	--without-linux-vga \
	--with-bitmap-terminals \
	--with-readline=bsd \
	--with-texdir=./usr/local/share/texmf/tex

ifneq (,$(filter $(DEB_HOST_ARCH), mips mips64el powerpc mipsel))
	conf_opts += --without-lua
endif

override_dh_auto_configure:
	mkdir -p $(BUILDDIR_NOX)
	cd $(BUILDDIR_NOX); CONFIG_SHELL=/bin/sh ./../../configure $(conf_opts) --with-qt=no --without-x --disable-wxwidgets
	mkdir -p $(BUILDDIR_X11)
	cd $(BUILDDIR_X11); CONFIG_SHELL=/bin/sh ../../configure $(conf_opts) --with-qt=no
	mkdir -p $(BUILDDIR_QT)
	cd $(BUILDDIR_QT); CONFIG_SHELL=/bin/sh ../../configure $(conf_opts)  --enable-qt

override_dh_auto_build-arch:
	dh_auto_build -a -- -C $(BUILDDIR_NOX)/src
	dh_auto_build -a -- -C $(BUILDDIR_X11) pkglibexecdir='$$(libexecdir)'
	dh_auto_build -a -- -C $(BUILDDIR_QT) pkglibexecdir='$$(libexecdir)'

override_dh_auto_build-indep:
	cd $(BUILDDIR_X11)/docs; $(MAKE); $(MAKE) pdf; $(MAKE) html; $(MAKE) info; ls
	rm -f $(BUILDDIR_X11)/docs/htmldocs/internals.pl
	rm -f $(BUILDDIR_X11)/docs/htmldocs/labels.pl
	rm -f $(BUILDDIR_X11)/docs/htmldocs/images.log
	rm -f $(BUILDDIR_X11)/docs/htmldocs/WARNINGS
	rm -f $(BUILDDIR_X11)/docs/gpcard.ps

override_dh_auto_install:
	$(MAKE) -C $(BUILDDIR_NOX) install DESTDIR=$(CURDIR)/debian/tmp/NOX/ \
		pkglibexecdir='$$(libexecdir)'
	mv $(CURDIR)/debian/tmp/NOX/usr/bin/gnuplot $(CURDIR)/debian/tmp/NOX/usr/bin/gnuplot-nox
	mv $(CURDIR)/debian/tmp/NOX/usr/share/man/man1/gnuplot.1 $(CURDIR)/debian/tmp/NOX/usr/share/man/man1/gnuplot-nox.1
	mv $(CURDIR)/debian/tmp/NOX/usr/share/gnuplot/gnuplot.gih $(CURDIR)/debian/tmp/NOX/usr/share/gnuplot/gnuplot-nox.gih
	$(MAKE) -C $(BUILDDIR_X11) install DESTDIR=$(CURDIR)/debian/tmp/X11/ \
		pkglibexecdir='$$(libexecdir)'
	mv $(CURDIR)/debian/tmp/X11/usr/bin/gnuplot $(CURDIR)/debian/tmp/X11/usr/bin/gnuplot-x11
	mv $(CURDIR)/debian/tmp/X11/usr/share/man/man1/gnuplot.1 $(CURDIR)/debian/tmp/X11/usr/share/man/man1/gnuplot-x11.1
	mv $(CURDIR)/debian/tmp/X11/usr/share/gnuplot/gnuplot.gih $(CURDIR)/debian/tmp/X11/usr/share/gnuplot/gnuplot-x11.gih
	$(MAKE) -C $(BUILDDIR_QT) install DESTDIR=$(CURDIR)/debian/tmp/QT/ \
		pkglibexecdir='$$(libexecdir)'
	mv $(CURDIR)/debian/tmp/QT/usr/bin/gnuplot $(CURDIR)/debian/tmp/QT/usr/bin/gnuplot-qt
	mv $(CURDIR)/debian/tmp/QT/usr/share/man/man1/gnuplot.1 $(CURDIR)/debian/tmp/QT/usr/share/man/man1/gnuplot-qt.1
	mv $(CURDIR)/debian/tmp/QT/usr/share/gnuplot/gnuplot.gih $(CURDIR)/debian/tmp/QT/usr/share/gnuplot/gnuplot-qt.gih
	rm -f $(CURDIR)/../demo/Makefile
	rm -f $(CURDIR)/../demo/plugin/Makefile
	rm -f $(BUILDDIR_X11)/demo/Makefil*
	rm -f $(BUILDDIR_X11)/demo/plugin/Makefil*

execute_after_dh_installman:
	rm -rf $(CURDIR)/debian/tmp/X11/usr/local
	rm -rf $(CURDIR)/debian/tmp/NOX/usr/local
	rm -rf $(CURDIR)/debian/tmp/X11/usr/share
	rm -rf $(CURDIR)/debian/tmp/NOX/usr/share
	rm -rf $(CURDIR)/debian/tmp/QT/usr/share/man

override_dh_installinfo:
	dh_installinfo -pgnuplot-doc $(BUILDDIR_X11)/docs/gnuplot.info

override_installchangelogs:
	dh_installchangelogs -pgnuplot-doc ChangeLog

execute_after_dh_installman-arch:
	# Fix manpage for nox-version. (Closes: #744218)
	sed -i 's/\[X11 options\] //g' $(MANPNOX)
	sed -i 's/plotting program/plotting program (no-X version)/g' $(MANPNOX)
	sed -i '/SH\ X11\ OPTIONS/,/command line\./ d' $(MANPNOX)

execute_after_dh_auto_clean:
	rm -rf $(BUILDDIR_NOX)
	rm -rf $(BUILDDIR_X11)
	rm -rf $(BUILDDIR_QT)

override_dh_compress-indep:
	dh_compress -i -Xexamples -Xtutorial -Xhtmldocs -X.dvi -X.pdf -X.ps

## gnuplot 6.0.2%2Bdfsg1

=== debian/watch ===
version=4
opts=repacksuffix=+dfsg1,dversionmangle=s/\+dfsg\d*$// https://sf.net/gnuplot/gnuplot-(\d\S+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## gnuplot 6.0.2+dfsg1

=== config/msvc/Makefile ===
#
# GNUPLOT Makefile Microsoft Visual C++ 2010 or newer

# In order to do parallel builds you can use the nmake replacement jom,
# see https://wiki.qt.io/Jom

# John Bollinger bbands@yahoo.com, 4 March 2002:
#   Added png support with zlib and libpng as subs of .\src
#     libpng and zlib can be downloaded from ftp://ftp.uu.net/graphics/png
#   Added pdf support with pdflib as a sub of .\src
#     pdflib can be downloaded from http://www.pdflib.com
#   Added MSC multi-thread support for compatibility with pdflib
# Bastian Maerkisch bmaerkisch@web.de:
#   Added support for binary version of the GD library (bgd.dll)
#     gdlib can be downloaded from http://www.libgd.org/
#     Development of libgd seems to have stalled:
#     Latest binary build can be found at http://www.libgd.org/releases/gd-latest-win32.zip
#     As of March 2011 this is version 2.0.34.
#   Removed zlib and libpng again as they're already included in bgd.dll
# Hans-Bernhard Broeker:
#   updated to current version of MSVC
#   undid silly name change for pgnuplot.exe, call console version gnuplot.exe instead
#   removed remainder of wgnuplot_pipes.exe support
#   isolated more configuration-dependent parts (gd, pdf, wx) to lines of their own,
#     so they can be turned on/off more easily.
# Bastian Maerkisch bmaerkisch@web.de:
#   Out of tree version. Moved to config\msvc
#   See ChangeLog for further changes.

#
# To compile with Visual C:
#	Optionally download gdlib to config\msvc\gdwin32
#	Optionally download pdflib to config\msvc\pdflib and compile it if you choose the source
#
#	Start the Microsoft Visual C++ command shell (e.g. via link installed setup)
#	change to the gnuplot\config\msvc directory
#   Edit the Makefile to match your setup. (If you don't have the optional libraries,
#   you will probably have to disable some parts.)
#	Now run:
#	  nmake
#

# Set to one iff doing a release build
RELEASE=0

# Compilation options, disable by setting to zero
# Is libgd available? (required by terminal png/jpeg/gif)?
GDLIB = 0
# Is pdflib available? (required by terminal pdf)
PDFLIB = 0
# Build wxt terminal? (requires GTK, wxWidgets, cairo and pango libraries)
# See http://wiki.wxwidgets.org/Microsoft_Visual_C%2B%2B_Guide
#     http://wiki.wxwidgets.org/Visual_Studio_2008_%289.0%29
WXT = 0
# Build Cairo Terminals (cairolatex, epslatex, pdflatex)
CAIRO = 0
# Build qt terminal?
QT = 0
# Set to one if you have Qt5 (instead of Qt4)
QT5 = 1
# Build the lua/tikz terminal?
LUA = 0
# Build caca terminal? Requires libcaca
# Requires libcaca version 0.99.beta15 or newer. A post-beta18
# svn version is recommended since it contains an improved
# win32 backend.
CACA = 0
# Enable if you want to use Direct2D 1.1 (Windows 8 and Windows 7 Platform Update)
DIRECT2D11 = 0

# Create debug build?
DEBUG = 0

# Create dependency files?
# Caveat:  This increases build time by more than 50%.
DEPEND = 0

# Location of additional libraries
#GDDIR = gdwin32
#LUADIR = lua
PDFDIR = pdflib
#QTDIR = C:\Qt\4.8.4
QTDIR = C:\Qt\5.8\msvc2015_64
#CAIRODIR = cairo-pango
#CACADIR = libcaca
CAIRODIR = d:\msvc-libs
LIBDIR =  d:\msvc-libs


# installation directory
DESTDIR = "$(PROGRAMFILES)\gnuplot"

TOP = ..\..

# directory for PostScript prolog and associated files
GNUPLOT_PS_DIR = share\\PostScript

# Similarly for javascript files for the canvas terminal:
GNUPLOT_JS_DIR = share\\js

# Similarly for scripts used by the lua terminal
GNUPLOT_LUA_DIR = share\\lua

# Install will put TeX files here:
GNUPLOT_TEX_DIR = share\\texmf\\tex

# directory for Qt translation files
GNUPLOT_QT_DIR = share\\qt

# gnuplot will look for gnuplotrc here:
GNUPLOT_SHARE_DIR = share

#CC = cl
LD = link

!IF "$(DEPEND)" == "1"
CCWRAP=cl-wrap.cmd obj dep
CCWRAPC=cl-wrap.cmd cobj cdep
!ENDIF

# compiler flags
# /I  means extra include directory
# /Fm means produce link map
# /Od means suppress optimizations (esp. for debug)
# /O2 means optimize for speed
# /Zi means prepare for codeview
# /MD means include multi-thread support (DLL)
# /GR means Enable Run-Time Type Information
!IF "$(DEBUG)" == "1"
CBASEFLAGS = /EHsc /GR /MDd /Od /nologo /Zi
!ELSE
CBASEFLAGS = /EHsc /GR /MD /O2 /nologo
!ENDIF
CFLAGS = $(CBASEFLAGS) /I. /I$(TOP) /I$(S) /I$(T) /DHAVE_CONFIG_H /D__MSC__ $(OPTIONS)
CFLAGS = $(CFLAGS) /DUNICODE /D_UNICODE
CFLAGS = $(CFLAGS) /DGNUPLOT_SHARE_DIR=\"$(GNUPLOT_SHARE_DIR)\"
WIN_CFLAGS =
CONSOLE_CFLAGS = /DWGP_CONSOLE
OPTIONS = /DUSE_MOUSE /DPIPES
OPTIONS = $(OPTIONS) /DGNUPLOT_HISTORY

EXTRA_TARGETS =

VERSION_CPPFLAGS = -DVERSION_MAJOR=\"5.5\" -DPATCHLEVEL=\"0\"

# flags for terminals
# see other terminal defines in term.h
TERMFLAGS = /I$(T) /DGNUPLOT_PS_DIR=\"$(GNUPLOT_PS_DIR)\" /DGNUPLOT_JS_DIR=\"$(GNUPLOT_JS_DIR)\"

# linker flags, append paths for external libs later
LDFLAGS = /nologo /MACHINE:$(MACHINE)
LDFLAGS = $(LDFLAGS) /MANIFEST:EMBED /MANIFESTINPUT:$(W)$(MANIFEST)
!IF "$(DEBUG)" == "1"
LDFLAGS = $(LDFLAGS) /DEBUG
!ENDIF
COMMONLIBS = kernel32.lib user32.lib gdi32.lib winspool.lib \
             comdlg32.lib comctl32.lib advapi32.lib shell32.lib \
             msimg32.lib gdiplus.lib shlwapi.lib \
             d2d1.lib dwrite.lib ole32.lib
CONSOLELIBS = ole32.lib oleaut32.lib comctl32.lib

!IFDEF LIBDIR
OPTIONS = $(OPTIONS) /I$(LIBDIR)\include
LDFLAGS = $(LDFLAGS) /libpath:$(LIBDIR)\lib
!ENDIF

!IF "$(RELEASE)" != "1"
OPTIONS = $(OPTIONS) /DDEVELOPMENT_VERSION
!ENDIF

!IF "$(GDLIB)" == "1"
OPTIONS = $(OPTIONS) /DHAVE_LIBGD /DHAVE_GD_H /DHAVE_GD_GIF /DGIF_ANIMATION /DHAVE_GD_PNG /DHAVE_GD_JPEG /DHAVE_GD_TTF
!IFDEF GDDIR
OPTIONS = $(OPTIONS) /I$(GDDIR)\include
LDFLAGS = $(LDFLAGS) /libpath:$(GDDIR)\lib
!ENDIF
!ENDIF

!IF "$(PDFLIB)" == "1"
OPTIONS = $(OPTIONS) /DHAVE_LIBPDF
!IFDEF PDFDIR
LDFLAGS = $(LDFLAGS) /libpath:$(PDFDIR)\pdflib
TERMFLAGS = $(TERMFLAGS) /I$(PDFDIR)\pdflib
!ENDIF
!ENDIF

!IF ("$(CAIRO)" == "1") || ("$(WXT)" == "1")
CAIROLIBS = glib-2.0.lib gobject-2.0.lib gmodule-2.0.lib \
	cairo.lib pango-1.0.lib pangocairo-1.0.lib
CFLAGS = $(CFLAGS) /DHAVE_CAIROPDF
TERMFLAGS = $(TERMFLAGS) /DHAVE_CAIROEPS
!IFDEF CAIRODIR
CFLAGS = $(CFLAGS) /I$(CAIRODIR)\include\glib-2.0 /I$(CAIRODIR)\lib\glib-2.0\include /I$(CAIRODIR)\include\pango-1.0 /I$(CAIRODIR)\include\msvc
!ENDIF
!ENDIF

!IF "$(WXT)" == "1"
WXTLIBS = wxmsw28.lib wxtiff.lib
!ENDIF

!IF "$(QT)" == "1"
!IF "$(DEBUG)" == "1"
!IF "$(QT5)" == "1"
QTLIBS = Qt5Cored.lib Qt5Guid.lib Qt5Networkd.lib Qt5Svgd.lib Qt5Widgetsd.lib Qt5PrintSupportd.lib qtmaind.lib
!ELSE
QTLIBS = QtCored4.lib QtGuid4.lib QtNetworkd4.lib QtSvgd4.lib
!ENDIF
!ELSE
!IF "$(QT5)" == "1"
QTLIBS = Qt5Core.lib Qt5Gui.lib Qt5Network.lib Qt5Svg.lib Qt5Widgets.lib Qt5PrintSupport.lib qtmain.lib
!ELSE
QTLIBS = QtCore4.lib QtGui4.lib QtNetwork4.lib QtSvg4.lib
!ENDIF
!ENDIF
CFLAGS = $(CFLAGS) /I$(QTDIR)\include /I$(QTDIR)\include\QtCore /I$(QTDIR)\include\QtGui /I$(QTDIR)\include\QtWidgets /I$(QTDIR)\include\QtNetwork /I$(QTDIR)\include\QtSvg /DQTGNUPLOT_DATA_DIR=\"$(GNUPLOT_QT_DIR)\"
LDFLAGS = $(LDFLAGS) /libpath:$(QTDIR)\lib
CFLAGS = $(CFLAGS) -DQTTERM -DQT_NO_OPENGL
MOC=$(QTDIR)\bin\moc
UIC=$(QTDIR)\bin\uic
RCC=$(QTDIR)\bin\rcc
EXTRA_TARGETS = $(EXTRA_TARGETS) gnuplot_qt.exe
!ENDIF

!IF "$(LUA)" == "1"
OPTIONS = $(OPTIONS) /DHAVE_LUA
!IFDEF LUADIR
OPTIONS = $(OPTIONS) /I$(LUADIR)/include
LDFLAGS = $(LDFLAGS) /libpath:$(LUADIR)
!ENDIF
TERMFLAGS = $(TERMFLAGS) /DGNUPLOT_LUA_DIR=\"$(GNUPLOT_LUA_DIR)\"
LUALIBS = lua52.lib
!ENDIF

!IF "$(CACA)" == "1"
OPTIONS = $(OPTIONS) /DHAVE_LIBCACA 
!IFDEF CACADIR
OPTIONS = $(OPTIONS) /I$(CACADIR)
LDFLAGS = $(LDFLAGS) /libpath:$(CACADIR)
!ENDIF
CACALIBS = libcaca.lib
!ENDIF

!IF "$(DIRECT2D11)" == "1"
OPTIONS = $(OPTIONS) /DHAVE_D2D11 /DHAVE_PRNTVPT
D2DLIBS = d3d11.lib dxguid.lib prntvpt.lib
!ENDIF


HELPFILE = wgnuplot.chm
!IF ("$(PLATFORM)" == "X64") || ("$(PLATFORM)" == "x64")
#HHC=""%%PROGRAMFILES(X86)%%\HTML Help Workshop\hhc""
HHC="C:\Program Files (x86)\HTML Help Workshop\hhc"
!ELSE
HHC="$(PROGRAMFILES)\HTML Help Workshop\hhc"
!ENDIF

!IF "$(PROCESSOR_ARCHITECTURE)" == "ALPHA"
MACHINE = $(PROCESSOR_ARCHITECTURE)
!ELSE
!IF ("$(PLATFORM)" == "X64") || ("$(PLATFORM)" == "x64")
MACHINE = X64
MANIFEST = wgnuplot.exe.manifest64
!ELSE
MACHINE = IX86
MANIFEST = wgnuplot.exe.manifest
!ENDIF
!ENDIF

!IF "$(DEPEND)" == "1"
BUILD_TARGETS = cl-wrap.cmd
!ENDIF

# macros for makefile.all
# Note: make sure that there is a space after the last backslash for jom compatibility

O=obj
S=$(TOP)\src
W=$(S)\win\\ 
WX=$(S)\wxterminal\\ 
Q=$(S)\qtterminal\\ 
T=$(TOP)\term\\ 
D=$(TOP)\docs\\ 
M=$(TOP)\demo\\ 

default: $(BUILD_TARGETS) wgnuplot.exe $(HELPFILE) wgnuplot.mnu $(M)bf_test.exe gnuplot.exe demo_plugin.dll $(EXTRA_TARGETS)

!INCLUDE $(S)\makefile.all

# Include the generated dependency files
!IF ![(for %i in (*.dep *.cdep) do @echo !INCLUDE %i) >Build.tmp]
! INCLUDE Build.tmp
! IF ![del Build.tmp]
! ENDIF
!ENDIF

OBJS = $(COREOBJS) version.obj

!IF "$(CAIRO)" == "1"
OBJS = $(OBJS) gp_cairo.$(O) gp_cairo_helpers.$(O)
!ENDIF

!IF "$(QT)" == "1"
OBJS = $(OBJS) qt_term.$(O)
GNUPLOTQTOBJS = gnuplot_qt.$(O) QtGnuplotWindow.$(O) \
QtGnuplotApplication.$(O) QtGnuplotWidget.$(O) \
QtGnuplotScene.$(O) QtGnuplotItems.$(O) \
QtGnuplotEvent.$(O) \
moc_QtGnuplotWindow.$(O) moc_QtGnuplotApplication.$(O) \
moc_QtGnuplotWidget.$(O) moc_QtGnuplotScene.$(O) \
moc_QtGnuplotEvent.$(O) qrc_QtGnuplotResource.$(O)

# Call the Qt resource compiler
qrc_QtGnuplotResource.cpp: $(Q)QtGnuplotResource.qrc
	$(RCC) -name QtGnuplotResource -o $@ $**

# Call the Qt ui compiler
ui_QtGnuplotSettings.h: $(Q)QtGnuplotSettings.ui
	$(UIC) -o $@ $**

moc_QtGnuplotWindow.cpp: $(Q)QtGnuplotWindow.h
	$(MOC) -o $@ $**

moc_QtGnuplotApplication.cpp: $(Q)QtGnuplotApplication.h
	$(MOC) -o $@ $**

moc_QtGnuplotWidget.cpp: $(Q)QtGnuplotWidget.h
	$(MOC) -o $@ $**

moc_QtGnuplotScene.cpp: $(Q)QtGnuplotScene.h
	$(MOC) -o $@ $**

moc_QtGnuplotEvent.cpp: $(Q)QtGnuplotEvent.h
	$(MOC) -o $@ $**

gnuplot_qt.exe: ui_QtGnuplotSettings.h $(GNUPLOTQTOBJS)
	$(LD) /entry:mainCRTStartup /subsystem:windows $(LDFLAGS) /map:gnuplot_qt.map /out:$@ $(GNUPLOTQTOBJS) $(QTLIBS) shell32.lib user32.lib
!ENDIF

WINOBJS = winmain.obj wgnuplib.obj wgraph.obj wprinter.obj wtext.obj \
	screenbuf.obj wpause.obj wmenu.obj gpexecute.obj wgdiplus.obj \
	wd2d.obj wredirect.obj

ALL_CONSOLE_OBJS = $(OBJS:.obj=.cobj) $(WINOBJS:.obj=.cobj)


# default rules
.cpp.obj:
	$(CC) /c $(CFLAGS) $(WIN_CFLAGS) $*.cpp /Fo$@

.cpp.cobj:
	$(CC) /c $(CFLAGS) $(CONSOLE_CFLAGS) $*.cpp /Fo$@


# Batch-mode script to both compile and produces .dep files suitable for NMAKE.
# Adopted from https://stackoverflow.com/a/36091560
# This looks more complicated than it is, see patch #756 for an explanation.
# This is roughly equivalent to -M -MM -MP -MT$@ -MF$(@R).dep in GNU make + gcc.
# The script requires three arguments: The obj file extension, the file extension for the
# dependencies, and the cl compiler command line.
cl-wrap.cmd: Makefile
	@echo @^%COMSPEC^% /v:on /e:on /c "@(set _args=%* & set _cl=!_args:*%3=! & set _cl=%3!_cl! & !_cl! /showIncludes & echo Exit: !ERRORLEVEL!)" ^| ^%COMSPEC^% /v:on /e:on /c "@for /f "tokens=1,* delims=]" %%%%A in ('find /v /n""') do @if %%%%~xB == .c (set _=%%%%~nB&rem.>!_!.%%2&echo %%%%B) else if %%%%~xB == .cpp (set _=%%%%~nB&rem.>!_!.%%2&echo %%%%B) else for /f "tokens=1,2,3,*" %%%%C in ("%%%%B") do @if %%%%C == Note: (set i=%%%%F&if /i "!i:Windows Kits=!"=="!i!" (if /i "!i:Visual Studio=!"=="!i!" ((echo !_!.%%1: !i!&echo "!i!":) >> !_!.%%2))) else if %%%%C == Exit: (exit /b %%%%D) else echo %%%%B" > $@

{$(S)}.c.obj:
	$(CCWRAP) $(CC) /c $(CFLAGS) $(WIN_CFLAGS) $(S)\$*.c

{$(S)}.c.cobj:
	$(CCWRAPC) $(CC) /c $(CFLAGS) $(CONSOLE_CFLAGS) $(S)\$*.c /Fo$@

{$(W)}.c.obj:
	$(CCWRAP) $(CC) /c $(CFLAGS) $(WIN_CFLAGS) $(W)$*.c /Fo$@

{$(W)}.c.cobj:
	$(CCWRAPC) $(CC) /c $(CFLAGS) $(CONSOLE_CFLAGS) $(W)$*.c /Fo$@

{$(W)}.cpp.obj:
	$(CCWRAP) $(CC) /c $(CFLAGS) $(WIN_CFLAGS) $(W)$*.cpp /Fo$@

{$(W)}.cpp.cobj:
	$(CCWRAPC) $(CC) /c $(CFLAGS) $(CONSOLE_CFLAGS) $(W)$*.cpp /Fo$@

{$(WX)}.c.obj:

=== debian/changelog ===
gnuplot (6.0.2+dfsg1-2ubuntu1) questing; urgency=medium

  * SECURITY UPDATE: Denial of Service
    - debian/patches/CVE-2025-3359.patch: Refactor font name parsing to
      prevent off by one error
    - debian/patches/CVE-2025-31176.patch: Add extra guard to prevent
      invalid read from plot->labels
    - debian/patches/CVE-2025-31178.patch: Use snprintf to protect
      against garbage user-supplied mouse format
    - debian/patches/CVE-2025-31179.patch: Add guard against trying to
      format a huge number as a time
    - debian/patches/CVE-2025-31180.patch: Handle nonlinear x2 or y2 axis
      with an incomplete definition
    - debian/patches/CVE-2025-31181.patch: Protect against double fclose()
      if two errors occur in a row
    - CVE-2025-3359
    - CVE-2025-31176
    - CVE-2025-31178
    - CVE-2025-31179
    - CVE-2025-31180
    - CVE-2025-31181
  * SECURITY UPDATE: Heap Buffer Overflow
    - debian/patches/CVE-2025-31177.patch: Add extra guard against y
      bound of dumb terminal charcell array
    - CVE-2025-31177

 -- Bruce Cable <bruce.cable@canonical.com>  Tue, 02 Sep 2025 19:27:10 +1000

gnuplot (6.0.2+dfsg1-2) unstable; urgency=medium

  * Team upload
  * The emacs dependency can be provided by both emacs-nox and emacs

    emacs-nox is the default, but any other flavor would work too.
    (Closes: #1024630)

 -- Dima Kogan <dkogan@debian.org>  Sat, 07 Jun 2025 00:39:00 -0700

gnuplot (6.0.2+dfsg1-1) unstable; urgency=medium

  * [5f60ec1] New upstream version 6.0.2+dfsg1. (Closes: #1064982).
  * [abe98eb] Refresh patches.

 -- Anton Gladky <gladk@debian.org>  Thu, 26 Dec 2024 22:06:51 +0100

gnuplot (6.0.0+dfsg1-3) unstable; urgency=medium

  * Team upload
  * Added "nox-only" profile to allow an arch-any build without qt or wxt
    dependencies. (Closes: #1067582)

 -- Dima Kogan <dkogan@debian.org>  Wed, 03 Apr 2024 13:29:20 -0700

gnuplot (6.0.0+dfsg1-2) unstable; urgency=medium

  [ Zixing Liu ]
  * [b9f2408] Fix a memory error in doc2tex when generating PDF files

  [ Anton Gladky ]
  * [6a963da] Remove duplicated dependency

 -- Anton Gladky <gladk@debian.org>  Wed, 13 Mar 2024 21:48:47 +0100

=== debian/control ===
--- 
+++ 
@@ -14,29 +14,28 @@
                liblua5.1-0-dev,
                libpango1.0-dev,
                libpng-dev,
-               qtbase5-dev,
-               qtbase5-dev-tools,
-               qttools5-dev-tools,
-               libqt5svg5-dev,
-               libx11-dev,
-               libxt-dev,
+               qtbase5-dev <!nox-only>,
+               qtbase5-dev-tools <!nox-only>,
+               qttools5-dev-tools <!nox-only>,
+               libqt5svg5-dev <!nox-only>,
+               libx11-dev <!nox-only>,
+               libxt-dev <!nox-only>,
                pkg-config,
-               libwxgtk3.2-dev,
-               libwxgtk3.2-dev,
+               libwxgtk3.2-dev <!nox-only>,
                zlib1g-dev
-Build-Depends-Indep: latex2html,
-                     texinfo,
-                     texlive-fonts-recommended,
-                     texlive-font-utils,
-                     texlive-latex-base,
-                     texlive-latex-extra,
-                     texlive-latex-recommended,
-                     texlive-science,
-                     texlive-xetex,
-                     texlive-fonts-extra,
-                     fonts-freefont-ttf,
-                     fonts-freefont-otf,
-                     emacs-nox
+Build-Depends-Indep: latex2html <!nox-only>,
+                     texinfo <!nox-only>,
+                     texlive-fonts-recommended <!nox-only>,
+                     texlive-font-utils <!nox-only>,
+                     texlive-latex-base <!nox-only>,
+                     texlive-latex-extra <!nox-only>,
+                     texlive-latex-recommended <!nox-only>,
+                     texlive-science <!nox-only>,
+                     texlive-xetex <!nox-only>,
+                     texlive-fonts-extra <!nox-only>,
+                     fonts-freefont-ttf <!nox-only>,
+                     fonts-freefont-otf <!nox-only>,
+                     emacs-nox <!nox-only> | emacs <!nox-only>
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/science-team/gnuplot
 Vcs-Git: https://salsa.debian.org/science-team/gnuplot.git
@@ -62,6 +61,7 @@
 
 Package: gnuplot-doc
 Architecture: all
+Build-Profiles: <!nox-only>
 Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends}
@@ -103,6 +103,7 @@
 
 Package: gnuplot-qt
 Architecture: any
+Build-Profiles: <!nox-only>
 Depends: gnuplot-data (= ${source:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
@@ -131,6 +132,7 @@
 
 Package: gnuplot-x11
 Architecture: any
+Build-Profiles: <!nox-only>
 Depends: gnuplot-data (= ${source:Version}),
          ${misc:Depends},
          ${shlibs:Depends}

=== debian/rules ===
--- 
+++ 
@@ -44,23 +44,60 @@
 override_dh_auto_configure:
 	mkdir -p $(BUILDDIR_NOX)
 	cd $(BUILDDIR_NOX); CONFIG_SHELL=/bin/sh ./../../configure $(conf_opts) --with-qt=no --without-x --disable-wxwidgets
+ifeq (,$(filter $(DEB_BUILD_PROFILES),nox-only))
 	mkdir -p $(BUILDDIR_X11)
 	cd $(BUILDDIR_X11); CONFIG_SHELL=/bin/sh ../../configure $(conf_opts) --with-qt=no
 	mkdir -p $(BUILDDIR_QT)
 	cd $(BUILDDIR_QT); CONFIG_SHELL=/bin/sh ../../configure $(conf_opts)  --enable-qt
+endif
 
 override_dh_auto_build-arch:
 	dh_auto_build -a -- -C $(BUILDDIR_NOX)/src
+ifeq (,$(filter $(DEB_BUILD_PROFILES),nox-only))
 	dh_auto_build -a -- -C $(BUILDDIR_X11) pkglibexecdir='$$(libexecdir)'
 	dh_auto_build -a -- -C $(BUILDDIR_QT) pkglibexecdir='$$(libexecdir)'
+endif
 
+# Currently the docs are built in the -x11 configuration. Moving them to the
+# -nox configuration causes some problems that I don't want to debug right now.
+# So I don't build gnuplot-doc in the nox-only profile at all
+ifeq (,$(filter $(DEB_BUILD_PROFILES),nox-only))
+# the upstream build isn't set up properly: 'make -n' and 'make pdf' say stuff like
+#
+#   No rule to make target '../src/bf_test', needed by 'binary1'
+#
+# So I manually do a "make" and then "make" for the separate targets.
 override_dh_auto_build-indep:
-	cd $(BUILDDIR_X11)/docs; $(MAKE); $(MAKE) pdf; $(MAKE) html; $(MAKE) info; ls
+	$(MAKE) -C $(BUILDDIR_X11)/docs      && \
+	$(MAKE) -C $(BUILDDIR_X11)/docs pdf  && \
+	$(MAKE) -C $(BUILDDIR_X11)/docs html && \
+	$(MAKE) -C $(BUILDDIR_X11)/docs info
+
 	rm -f $(BUILDDIR_X11)/docs/htmldocs/internals.pl
 	rm -f $(BUILDDIR_X11)/docs/htmldocs/labels.pl
 	rm -f $(BUILDDIR_X11)/docs/htmldocs/images.log
 	rm -f $(BUILDDIR_X11)/docs/htmldocs/WARNINGS
 	rm -f $(BUILDDIR_X11)/docs/gpcard.ps
+
+override_dh_installinfo:
+	dh_installinfo -pgnuplot-doc $(BUILDDIR_X11)/docs/gnuplot.info
+
+override_installchangelogs:
+	dh_installchangelogs -pgnuplot-doc ChangeLog
+
+override_dh_compress-indep:
+	dh_compress -i -Xexamples -Xtutorial -Xhtmldocs -X.dvi -X.pdf -X.ps
+
+
+else
+
+override_dh_auto_build-indep:
+	@echo "ERROR! The 'nox-only' profile is meant for arch-any builds ONLY. Currently this profile would"
+	@echo "try to install some non-existing qt files into the gnuplot-data package, which would cause"
+	@echo "dh_install to fail. See https://bugs.debian.org/1067582"
+	false
+
+endif
 
 override_dh_auto_install:
 	$(MAKE) -C $(BUILDDIR_NOX) install DESTDIR=$(CURDIR)/debian/tmp/NOX/ \
@@ -68,6 +105,7 @@
 	mv $(CURDIR)/debian/tmp/NOX/usr/bin/gnuplot $(CURDIR)/debian/tmp/NOX/usr/bin/gnuplot-nox
 	mv $(CURDIR)/debian/tmp/NOX/usr/share/man/man1/gnuplot.1 $(CURDIR)/debian/tmp/NOX/usr/share/man/man1/gnuplot-nox.1
 	mv $(CURDIR)/debian/tmp/NOX/usr/share/gnuplot/gnuplot.gih $(CURDIR)/debian/tmp/NOX/usr/share/gnuplot/gnuplot-nox.gih
+ifeq (,$(filter $(DEB_BUILD_PROFILES),nox-only))
 	$(MAKE) -C $(BUILDDIR_X11) install DESTDIR=$(CURDIR)/debian/tmp/X11/ \
 		pkglibexecdir='$$(libexecdir)'
 	mv $(CURDIR)/debian/tmp/X11/usr/bin/gnuplot $(CURDIR)/debian/tmp/X11/usr/bin/gnuplot-x11
@@ -78,23 +116,21 @@
 	mv $(CURDIR)/debian/tmp/QT/usr/bin/gnuplot $(CURDIR)/debian/tmp/QT/usr/bin/gnuplot-qt
 	mv $(CURDIR)/debian/tmp/QT/usr/share/man/man1/gnuplot.1 $(CURDIR)/debian/tmp/QT/usr/share/man/man1/gnuplot-qt.1
 	mv $(CURDIR)/debian/tmp/QT/usr/share/gnuplot/gnuplot.gih $(CURDIR)/debian/tmp/QT/usr/share/gnuplot/gnuplot-qt.gih
+	rm -f $(BUILDDIR_X11)/demo/Makefil*
+	rm -f $(BUILDDIR_X11)/demo/plugin/Makefil*
+endif
 	rm -f $(CURDIR)/../demo/Makefile
 	rm -f $(CURDIR)/../demo/plugin/Makefile
-	rm -f $(BUILDDIR_X11)/demo/Makefil*
-	rm -f $(BUILDDIR_X11)/demo/plugin/Makefil*
 
 execute_after_dh_installman:
+	rm -rf $(CURDIR)/debian/tmp/NOX/usr/local
+	rm -rf $(CURDIR)/debian/tmp/NOX/usr/share
+ifeq (,$(filter $(DEB_BUILD_PROFILES),nox-only))
 	rm -rf $(CURDIR)/debian/tmp/X11/usr/local
-	rm -rf $(CURDIR)/debian/tmp/NOX/usr/local
 	rm -rf $(CURDIR)/debian/tmp/X11/usr/share
-	rm -rf $(CURDIR)/debian/tmp/NOX/usr/share
 	rm -rf $(CURDIR)/debian/tmp/QT/usr/share/man
+endif
 
-override_dh_installinfo:
-	dh_installinfo -pgnuplot-doc $(BUILDDIR_X11)/docs/gnuplot.info
-
-override_installchangelogs:
-	dh_installchangelogs -pgnuplot-doc ChangeLog
 
 execute_after_dh_installman-arch:
 	# Fix manpage for nox-version. (Closes: #744218)
@@ -104,8 +140,8 @@
 
 execute_after_dh_auto_clean:
 	rm -rf $(BUILDDIR_NOX)
+ifeq (,$(filter $(DEB_BUILD_PROFILES),nox-only))
 	rm -rf $(BUILDDIR_X11)
 	rm -rf $(BUILDDIR_QT)
+endif
 
-override_dh_compress-indep:
-	dh_compress -i -Xexamples -Xtutorial -Xhtmldocs -X.dvi -X.pdf -X.ps
